/* -*- mode: c++ -*- */

%module frameCPP

%{
#include "general/types.hh"
#include "framecpp/Dimension.hh"

using namespace FrameCPP;
%}

%import "framecpp/Dimension.hh"

class Dimension
{
public:
  typedef DIMENSION_NDIM_TYPE	nDim_type;
  typedef DIMENSION_NX_TYPE	nx_type;
  typedef DIMENSION_DX_TYPE	dx_type;
  typedef DIMENSION_STARTX_TYPE	startX_type;

  Dimension( );

  Dimension( nx_type Nx, dx_type Dx, const char* UnitX, startX_type StartX );

  nx_type GetNx( ) const;
   
  dx_type GetDx( ) const;
      
  startX_type GetStartX( ) const;

  //---------------------------------------------------------------------
  /// \brief Retrieve the description of how to interpret each element
  ///
  /// \return
  ///     The description of how to interpret each element
  //---------------------------------------------------------------------
  const std::string& GetUnitX( ) const;

  void SetDx( dx_type Dx );
      
  void SetNx( nx_type Nx );
   
  void SetStartX( startX_type StartX );

  %insert("python") %{
    nx = property( fget=lambda d:d.GetNx( ) )
    dx = property( fget=lambda d:d.GetDx( ) )
    startX = property( fget=lambda d:d.GetStartX( ) )
    unitX = property( fget=lambda d:d.GetUnitX( ) )
  %}
};
